<?php
/*
Plugin Name: Watermark for Photopress
Plugin URI: http://familypress.net/photopress/
Description: Watermarking plugin for Photopress.
Version: 0.1
Author: Isaac Wedin
Author URI: http://familypress.net/
*/

/* 

Original hack contributed by Marcus Kimpenhaus, pluginification by Isaac.

Put this file somewhere in your plugins folder, such as in the photopress folder, and activate it. (It's included with Photopress so you just need to activate it.) Set the options at Options:Photopress. Images will be marked as you upload them. Use Manage:Photopress:Maintain:Mass Watermark to mark all of your existing images.

*/

/*-------------The Hooks and Additions--------------*/

add_action('pp_options','pp_watermark_options');

// This stuff gets placed at the bottom of the Photopress options page.
function pp_watermark_options() {
	global $pp_options;
	echo '
		<tr>
			<th scope="row">' . __('Watermark type for inserted images:','photopress') . '</th>
			<td>
			<label><input name="watermark_type" type="radio" value="none" ';
			if ($pp_options['watermark_type'] == 'none') {echo 'checked="checked" ';}
			echo '/> ' . __('None','photopress') . '</label>
			<label><input name="watermark_type" type="radio" value="text" ';
			if ($pp_options['watermark_type'] == 'text') {echo 'checked="checked" ';}
			echo '/> ' . __('Text','photopress') . '</label>
			<label><input name="watermark_type" type="radio" value="image" ';
			if ($pp_options['watermark_type'] == 'image') {echo 'checked="checked" ';}
			echo ' /> ' . __('Image','photopress') . '</label><br />' . __('Descide wether your images will be shown as they are or be marked by a text-string or an image of your choice.','photopress') . '
			</td>
		</tr>
		<tr>
			<th scope="row">' . __('Vertical watermark alignment at image:','photopress') . '</th>
			<td>
			<label><input name="vertical_watermark_alignment" type="radio" value="top" ';
			if ($pp_options['vertical_watermark_alignment'] == 'top') {echo 'checked="checked" ';}
			echo '/> ' . __('Top','photopress') . '</label>
			<label><input name="vertical_watermark_alignment" type="radio" value="bottom" ';
			if ($pp_options['vertical_watermark_alignment'] == 'bottom') {echo 'checked="checked" ';}
			echo ' /> ' . __('Bottom','photopress') . '</label><br />' . __('Choose the vertical position of the watermark.','photopress') . '
			</td>
		</tr>
		<tr>
			<th scope="row">' . __('Horizontal watermark alignment at image:','photopress') . '</th>
			<td>
			<label><input name="horizontal_watermark_alignment" type="radio" value="left" ';
			if ($pp_options['horizontal_watermark_alignment'] == 'left') {echo 'checked="checked" ';}
			echo '/> ' . __('Left','photopress') . '</label>
			<label><input name="horizontal_watermark_alignment" type="radio" value="right" ';
			if ($pp_options['horizontal_watermark_alignment'] == 'right') {echo 'checked="checked" ';}
			echo ' /> ' . __('Right','photopress') . '</label><br />' . __('Choose the horizontal position of the watermark.','photopress') . '
			</td>
		</tr>
		<tr>
			<th scope="row">' . __('Watermark transparency:','photopress') . '</th>
			<td><input name="watermark_transparency" type="text" id="watermark_transparency" value="' . $pp_options['watermark_transparency'] . '" size="3" /><br />' . __('Choose the transparency of the watermark - it has to be between 0 - 100.','photopress') . '</td>
		</tr>
		<tr>
			<th scope="row">' . __('Watermark padding:','photopress') . '</th>
			<td><input name="watermark_padding" type="text" id="watermark_padding" value="' . $pp_options['watermark_padding'] . '" size="3" /><br />' . __('Choose the padding around the watermark in px.','photopress') . '</td>
		</tr>
		<tr>
			<th scope="row">' . __('Watermark logo:','photopress') . '</th>
			<td><input name="watermark_logo" type="text" id="watermark_logo" value="' . $pp_options['watermark_logo'] . '" size="40" /><br />' . __('Address of your watermark-logo, beginning from your wordpress-folder. Must have if you choose watermark type \'image\'','photopress') . '</td>
		</tr>
		<tr>
			<th scope="row">' . __('Watermark text:','photopress') . '</th>
			<td><input name="watermark_text" type="text" id="watermark_text" value="' . $pp_options['watermark_text'] . '" size="40" /><br />' . __('Text of your watermark. Must have if you choose watermark type \'text\'','photopress') . '</td>
		</tr>
		<tr>
			<th scope="row">' . __('Watermark text size:','photopress') . '</th>
			<td><input name="watermark_text_size" type="text" id="watermark_text_size" value="' . $pp_options['watermark_text_size'] . '" size="10" /><br />' . __('Size of the text of your watermark. Must have if you choose watermark type \'text\' Must be between 1 - 5.','photopress') . '</td>
		</tr>
		<tr>
			<th scope="row">' . __('Watermark text color:','photopress') . '</th>
			<td><input name="watermark_text_color" type="text" id="watermark_text_color" value="' . $pp_options['watermark_text_color'] . '" size="10" /><br />' . __('Color of your watermark-text in hex style (such as #FFFFFF for white). Must have if you choose watermark type \'text\'','photopress') . '</td>
		</tr>
		<tr>
			<th scope="row">' . __('Watermark text shadow color:','photopress') . '</th>
			<td><input name="watermark_text_shadow_color" type="text" id="watermark_text_shadow_color" value="' . $pp_options['watermark_text_shadow_color'] . '" size="10" /><br />' . __('Color of the shadow of your watermark-text in hex style. Must have if you choose watermark type \'text\'','photopress') . '</td>
		</tr>
';
}

add_action('pp_maintain_button','pp_mass_watermark_button');

// inserted onto the Maintain page - should include a description and the button itself
function pp_mass_watermark_button() {
	echo "<tr>\n<td><p>" . __('<strong>Watermark Photos</strong> adds a watermark to all photos. There is no check wether one photo was allready marked. You should only use this as initial watermarking when there you allready have photos uploaded after upgrading.') . "</p></td>\n<td>" . '<form name="pp_album_cats" method="post"><input type="hidden" name="pp_mass_watermark" value="update" /><p class="submit"><input type="submit" name="Submit" value="' . __('Watermark Photos','photopress') . ' &raquo;" /></p>' . "</form></td>\n</tr>\n";
}

add_action('pp_process','pp_do_mass_watermark');

// This happens at the start of the Photopress Management page.
function pp_do_mass_watermark() {
	if (isset($_POST['pp_mass_watermark'])) {
		$marked = pp_mass_watermark();
		echo '<div class="updated">';
		printf(__('Marked %s images.','photopress'),$marked);
		echo '</div>';
	}
}

add_action('pp_defaults','pp_watermark_defaults');

// This is added to the Photopress option defaults.
function pp_watermark_defaults() {
	if (empty($pp_options['watermark_type'])) {
		$pp_options['watermark_type'] = 'none';
	}
	if (empty($pp_options['vertical_watermark_alignment'])) {
		$pp_options['vertical_watermark_alignment'] = 'bottom';
	}
	if (empty($pp_options['horizontal_watermark_alignment'])) {
		$pp_options['horizontal_watermark_alignment'] = 'right';
	}
	if (empty($pp_options['watermark_transparency'])) {
		$pp_options['watermark_transparency'] = '35';
	}
	if (empty($pp_options['watermark_padding'])) {
		$pp_options['watermark_padding'] = '5';
	}
	if (empty($pp_options['watermark_text'])) {
		$pp_options['watermark_text'] = 'photopress';
	}
	if (empty($pp_options['watermark_text_size'])) {
		$pp_options['watermark_text_size'] = '3';
	}
	if (empty($pp_options['watermark_text_color'])) {
		$pp_options['watermark_text_color'] = '#FFFFFF';
	}
	if (empty($pp_options['watermark_text_shadow_color'])) {
		$pp_options['watermark_text_shadow_color'] = '#000000';
	}
}

add_action('pp_upload','pp_watermark_upload');

function pp_watermark_upload() {
	global $destination;
	pp_watermark($destination);
}

/*--------The Functions---------------*/

// Watermarking wrapper function.
function pp_watermark($file) {
	global $pp_options;
	if ($pp_options['watermark_type'] == 'text') {
		return pp_watermark_text($file);
	} else if  ($pp_options['watermark_type'] == 'image') {
		return pp_watermark_image($file);
	}
}

// Watermark with text.
function pp_watermark_text($file) {
	global $pp_options;
	if (file_exists($file)) {
		// 1 = GIF, 2 = JPEG, 3 = PNG
		$type = getimagesize($file);
		// if the associated function doesn't exist - then it's not handle.
		if (!function_exists('imagegif') && $type[2] == 1) {
			$error = __('Filetype not supported. Image not watermarked.','photopress');
		} elseif (!function_exists('imagejpeg') && $type[2] == 2) {
			$error = __('Filetype not supported. Image not watermarked.','photopress');
		} elseif(!function_exists('imagepng') && $type[2] == 3) {
			$error = __('Filetype not supported. Image not watermarked.','photopress');
		} else {
			switch ($type['2']) {
				case '1':
					$image = imagecreatefromgif($file);
					break;
				case '2':
					$image = imagecreatefromjpeg($file);
					break;
				case '3':
					$image = imagecreatefrompng($file);
					break;
				default;
					return $error = __('Filetype not supported. Image not watermarked.','photopress');
			}
			if (function_exists('imageantialias')) {
				imageantialias($image, TRUE);
			}
			// watermark settings -------------------------------------------------
			$hex = $pp_options['watermark_text_color'];
			// remove the pound
			if (strlen ($hex) > 6) $hex = substr ($hex, 1, 7);
			// default to white
			if (strlen ($hex) < 6) $hex = 'FFFFFF';
			$text_r = hexdec (substr ($hex, 0, 2));
			$text_g = hexdec (substr ($hex, 2, 2));
			$text_b = hexdec (substr ($hex, 4, 2));
			$hex = $pp_options['watermark_text_shadow_color'];
			// remove the pound
			if (strlen ($hex) > 6) $hex = substr ($hex, 1, 7);
			// default to black
			if (strlen ($hex) < 6) $hex = '000000';
			$shadow_r = hexdec (substr ($hex, 0, 2));
			$shadow_g = hexdec (substr ($hex, 2, 2));
			$shadow_b = hexdec (substr ($hex, 4, 2));
			// 1-5; font size
			$font_size = $pp_options['watermark_text_size'];
			// text to be inserted
			$text = $pp_options['watermark_text'];
			// text color
			$text_color = imagecolorclosest($image, $text_r, $text_g, $text_b);
			// shadow color
			$shadow_color = imagecolorclosest($image, $shadow_r, $shadow_g, $shadow_b);
			//$pp_options['watermark_shadow_offset']; // shadow offset in pixels
			$shadow_offset = 4;
			// maximum text width
			$maxwidth = 200;
			// horizontal alignment: left, right
			$halign = $pp_options['horizontal_watermark_alignment'];
			// vertical alignment: top bottom
			$valign = $pp_options['vertical_watermark_alignment'];
			// amount of space between text & image border
			$padding = $pp_options['watermark_padding'];
			// jpeg compression quality of output image. 100 is best quality, but fairly large in filesize. 75 is default GD value.				
			$image_quality = $pp_options['quality'];
			// --------------------------------------------------------------------
			$font_width  = imagefontwidth($font_size);
			$font_height = imagefontheight($font_size);
			// So that shadow is not off image on right align & bottom valign
			$margin = floor($padding + $shadow_offset) / 2;
			if ($maxwidth != NULL) {
				$max_chars_per_line = floor(($maxwidth - ($margin * 2)) / $font_width);
				$text = wordwrap ($text, $max_chars_per_line, "\n", 1);
			}
			$lines = explode("\n", $text);
			switch ($valign) {
				case "bottom":
					$y = imagesy($image) - (($font_height * sizeof($lines)) + $margin);
					break;
				default:
					$y = $margin;
					break;
			}
			switch ($halign) {
				case "right":
					while (list($numl, $line) = each ($lines)) {
						imagestring($image, $font_size, (imagesx($image) - $font_width * strlen($line)) - $margin + $shadow_offset, ($y + $shadow_offset), $line, $shadow_color);
						imagestring($image, $font_size, (imagesx($image) - $font_width * strlen($line)) - $margin, $y, $line, $text_color);
						$y += $font_height;
					}
					break;
				default:
					while (list($numl, $line) = each ($lines)) {
						imagestring($image, $font_size, $margin + $shadow_offset, ($y + $shadow_offset), $line, $shadow_color);
						imagestring($image, $font_size, $margin, $y, $line, $text_color);
						$y += $font_height;
					}
					break;
			}
			switch ($type['2']) {
				case '1':
					imagegif($image, $file);
					break;
				case '2':
					imagejpeg($image, $file, $image_quality);
					break;
				case '3':
					imagepng($image, $file);
					break;
			}
			@imagedestroy($image);
		}
	}
	if (!empty($error)) {
		return $error;
	} else {
		return 1;
	}
}

// Watermark with an image.
function pp_watermark_image($file) {
	global $pp_options;
	if (file_exists($file)) {
		// 1 = GIF, 2 = JPEG, 3 = PNG
		$type = getimagesize($file);
		// if the associated function doesn't exist - then it's not handle.
		if (!function_exists('imagegif') && $type[2] == 1) {
			$error = __('Filetype not supported. Image not watermarked.','photopress');
		} elseif (!function_exists('imagejpeg') && $type[2] == 2) {
			$error = __('Filetype not supported. Image not watermarked.','photopress');
		} elseif(!function_exists('imagepng') && $type[2] == 3) {
			$error = __('Filetype not supported. Image not watermarked.','photopress');
		} else {
			switch ($type['2']) {
				case '1':
					$image = imagecreatefromgif($file);
					break;
				case '2':
					$image = imagecreatefromjpeg($file);
					break;
				case '3':
					$image = imagecreatefrompng($file);
					break;
				default;
					return $error = __('Filetype not supported. Image not watermarked.','photopress');
			}
			if (function_exists('imageantialias')) {
				imageantialias($image, TRUE);
			}
			// watermark settings -------------------------------------------------
			// logo image inside 'wordpress' directory
			$logo = ABSPATH . $pp_options['watermark_logo'];
			// horizontal alignment: left, right
			$halign = $pp_options['horizontal_watermark_alignment'];
			// vertical alignment: top bottom
			$valign = $pp_options['vertical_watermark_alignment'];
			// amount of space between text & image border
			$padding = $pp_options['watermark_padding'];
			// jpeg compression quality of output image. 100 is best quality, but fairly large in filesize. 75 is default GD value.				
			$image_quality = $pp_options['quality'];
			// 100 is no transparency; 0 is fully transparent, JPEG & GIF logo only
			$opacity = $pp_options['watermark_transparency'];
			// logo color which should be transparent (x-coord: default 0)
			$logo_transparent_x = 0;
			// logo color which should be transparent (y-coord: default 0)
			$logo_transparent_y = 0;
			// --------------------------------------------------------------------
			if (file_exists($logo)) {
				$logo_type = getimagesize($logo);
				// 2 = JPG, 3 = PNG
				switch ($logo_type['2']) {
					case '2':
						$logo = imagecreatefromjpeg($logo);
						break;
					case '3':
						$logo = imagecreatefrompng($logo);
						break;
					default:
						return $error = __('Logo filetype not supported. Image not watermarked.','photopress');
				}
				// determine the position of the logo
				$image_x = imagesx($image);
				$image_y = imagesy($image);
				$logo_x = imagesx($logo);
				$logo_y = imagesy($logo);
				switch ($valign) {
					case 'bottom':
						$logo_pos_y = $image_y - $logo_y - $padding;
						break;
					default:
						$logo_pos_y = $padding;
						break;
				}
				switch ($halign) {
					case 'right':
						$logo_pos_x = $image_x - $logo_x - $padding;
						break;
					default:
						$logo_pos_x = $padding;
						break;
				}
				switch ($logo_type['2']) {
					case '2':
						imagecolortransparent($logo, imagecolorat($logo, $logo_transparent_x, $logo_transparent_y));
						imagecopymerge($image, $logo, $logo_pos_x, $logo_pos_y, 0, 0, $logo_x, $logo_y, $opacity);
						break;
					case '3':
						imagealphablending($image, TRUE);
						imagecolortransparent($logo, imagecolorat($logo, $logo_transparent_x, $logo_transparent_y));
						imagecopymerge($image, $logo, $logo_pos_x, $logo_pos_y, 0, 0, $logo_x, $logo_y, $opacity);
						break;
				}
				switch ($type['2']) {
					case '1':
						imagegif($image, $file);
						break;
					case '2':
						imagejpeg($image, $file, $image_quality);
						break;
					case '3':
						imagepng($image, $file);
						break;
				}
				@imagedestroy($image);
			} else {
				$error = __('Watermark logo was not found. Image not watermarked','photopress');
			}
		}
	}
	if (!empty($error)) {
		return $error;
	} else {
		return 1;
	}
}

// Mass watermarking function.
function pp_mass_watermark() {
	global $pp_options;
	$images = pp_folder_contents();
	$imagesdone = 0;
	foreach ((array)$images as $image) {
		$pathtoimage = $pp_options['photospath'] . '/' . $image;
		$pathtoorig = $pp_options['photospath'] . '/' . $pp_options['origprefix'] . $image;
		if (file_exists($pathtoimage)) {
			if (($pp_options['originals'] == '1') && !is_file($pathtoorig)) {
				@copy($pathtoimage,$pathtoorig);
			}  
			$marked = pp_watermark($pathtoimage);
			if ($marked == 1) {
				$imagesdone++;
			} else {
				echo $marked;
			}
		}
	}
	return $imagesdone;
}

?>
